// MyTime.cpp : implementation file
//
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "MyStream.h"
#include "MyTime.h"


int CMyTime::validate(int m, int mi, int ma)
{
  if(m<mi)m=mi;
  if(m>ma)m=ma;
  return m;
}
int CMyTime::setn(char* ni)
{
  if(name != ni)
  {
    delete name; 
    name_length = strlen(ni)+1; 
    name = new char[name_length];
    strcpy(name, ni); 
  }
  return 1;
}
int CMyTime::setc(char* ci)
{
  if(comment != ci)
  {
    delete comment; 
    comment_length = strlen(ci)+1; 
    comment = new char[comment_length];
    strcpy(comment, ci); 
  }
  return 1;
}
CMyTime::CMyTime(int hi, int mi = 0, int si = 0, 
                 char* ni = "name", char* ci = "comment")
{
  myofs << "CMyTime: in parametric constructor, hou=" << hi << "; min=" << mi << "; sec=" << si;
  myofs << "; name=" << ni << "; comment=" << ci << endl; 
  hou = validate(hi, 0, 23);
  min = validate(mi, 0, 59);
  sec = validate(si, 0, 59);
  name_length = 2;
  name = new char[name_length];
  strcpy(name, "n");
  setn(ni);
  comment_length = 2;
  comment = new char[comment_length];
  strcpy(comment, "c");
  setc(ci);
}
CMyTime::CMyTime()
{
  hou = validate(12, 0, 23);
  min = validate(0, 0, 59);
  sec = validate(0, 0, 59);
  name_length = 2;
  name = new char[name_length];
  strcpy(name, "n");
  setn("");
  comment = new char[2];
  strcpy(comment, "c");
  setc("    CMyTime");
  myofs << "CMyTime: in default constructor, hou=" << hou << "; min=" << min << "; sec=" << sec;
  myofs << "; name=" << name << "; comment=" << comment << endl; 
}
CMyTime::CMyTime(const CMyTime& cmt)
{
  hou = cmt.hou;
  min = cmt.min;
  sec = cmt.sec;
  name_length = 2;
  name = new char[name_length];
  strcpy(name, "n");
  setn(cmt.name);
  comment_length = 2;
  comment = new char[comment_length];
  strcpy(comment, "c");
  setc(cmt.comment);
  myofs << "CMyTime: in copy constructor, hou=" << hou << "; min=" << min << "; sec=" << sec;
  myofs << "; name=" << name << "; comment=" << comment << endl; 
} 
CMyTime::~CMyTime()
{
  myofs << "CMyTime: in destructor, hou=" << hou << "; min=" << min << "; sec=" << sec;
  myofs << "; name=" << name << "; comment=" << comment << endl; 
  delete name;
  name_length = 0;
  delete comment;
  comment_length = 0;
}
CMyTime& CMyTime::operator=(CMyTime& cmt)
{
  if(this != &cmt){ 
	  hou = cmt.hou;
	  min = cmt.min;
	  sec = cmt.sec;
    setn(cmt.name);
    setc(cmt.comment);
  }
	return *this;
}
bool CMyTime::operator<(const CMyTime& cmt)
{
	if(hou<cmt.hou) return true;
	if(hou>cmt.hou) return false;
	if(min<cmt.min) return true;
	if(min>cmt.min) return false;
  if(sec<cmt.sec) return true;
  return false;
}
bool CMyTime::operator>(const CMyTime& cmt)
{
	if(hou>cmt.hou) return true;
	if(hou<cmt.hou) return false;
	if(min>cmt.min) return true;
	if(min<cmt.min) return false;
  if(sec>cmt.sec) return true;
  return false;
}
bool CMyTime::operator==(const CMyTime& cmt)
{
	if(hou != cmt.hou) return false;
	if(min != cmt.min) return false;
  if(sec != cmt.sec) return false;
  return true;
}
CMyTime::operator int()const
{
  return sec + 60*(min + 60*hou);
}
bool CMyTime::operator!=(const CMyTime& cmt)
{
	if(hou != cmt.hou) return true;
	if(min != cmt.min) return true;
  if(sec != cmt.sec) return true;
  return false;
}
CMyTime& CMyTime::operator!()
{
  char buf[BUFLEN]; int k, m;
  strcpy(buf, name);
  k = strlen(buf);
  for(m=0; m<k; m++) 
    name[m] = buf[k-m-1];
  strcpy(buf, comment);
  k = strlen(buf);
  for(m=0; m<k; m++)
    comment[m] = buf[k-m-1];
	if(min==0 && sec==0 && hou==0) 
    return *this;
  if(min==0 && sec==0)
  {
    hou = 24-hou;
    return *this;
  }
  if(sec==0)
  {
    min = 60-min;
    hou = 23-hou;
    return *this;
  }
  sec = 60-sec;
	min = 59-min;
  hou = 23-hou;
  return *this;
}
CMyTime operator+(CMyTime& cmt1, CMyTime& cmt2)
{
  CMyTime cmt; 
  int m, n, k;
  cmt.setn(cmt1.name);
  cmt.setc(cmt2.comment);
  k = cmt1.sec + cmt2.sec;
  m = 0;
  if (k > 59)
  {
    k -= 60;
    m = 1;
  }
  cmt.sets(k);
  k = cmt1.min + cmt2.min + m;
  n = 0;
  if (k > 59)
  {
    k -= 60;
    n = 1;
  }
  cmt.setm(k);
  k = cmt1.hou + cmt2.hou + n;
  cmt.seth(k%24);
  return cmt;
}
CMyTime operator+(int sec1, CMyTime& cmt2)
{
  CMyTime cmt; 
  int m, n, k;
  cmt.setn(cmt2.name);
  cmt.setc(cmt2.comment);
  k = sec1 + cmt2.sec;
  m = 0;
  while(k > 59)
  {
    k -= 60;
    m += 1;
  }
  cmt.sets(k);
  k = cmt2.min + m;
  n = 0;
  while(k > 59)
  {
    k -= 60;
    n += 1;
  }
  cmt.setm(k);
  k = cmt2.hou + n;
  cmt.seth(k%24);
  return cmt;
}
CMyTime operator-(CMyTime& cmt1, int sec2)
{
  CMyTime cmt; 
  int m, n, k;
  cmt.setn(cmt1.name);
  cmt.setc(cmt1.comment);
  k = cmt1.sec - sec2;
  m = 0;
  while(k < 0)
  {
    k += 60;
    m -= 1;
  }
  cmt.sets(k);
  k = cmt1.min + m;
  n = 0;
  while(k < 0)
  {
    k += 60;
    n -= 1;
  }
  cmt.setm(k);
  k = cmt1.hou + n;
  cmt.seth(k%24);
  return cmt;
}
CMyTime operator+(CMyTime& cmt1, int sec2)
{
  CMyTime cmt; 
  cmt = sec2 + cmt1;
  return cmt;
}
int CMyTime::MyPrint(char* title, char* buf)
{
	char buf1[BUFLEN];
	sprintf(buf1, "%3d hour, %3d min, %3d sec ", hou, min, sec);
	strcpy(buf, title);
	strcat(buf, buf1);
	strcat(buf, " ");
	strcat(buf, name);
  strcat(buf, " ");
  strcat(buf, comment);
	return 1;
}
ofstream& operator<<(ofstream& ofs, CMyTime& cmt)
{
	char buf[BUFLEN];
  cmt.MyPrint("", buf);
  ofs << buf;
  return ofs;
} 
int change(CMyTime* ptim1, CMyTime* ptim2)
{
  CMyTime* ptim = new CMyTime;
  *ptim = *ptim1;
  *ptim1 = *ptim2;
  *ptim2 = *ptim;
  delete ptim;
  return 1;
}
int CMyTime::change(CMyTime* ptim2)
{
  CMyTime* ptim = new CMyTime;
  *ptim = *this;
  *this = *ptim2;
  *ptim2 = *this;
  delete ptim;
  return 1;
}

int decr(int& ncur, int N){ncur--; if(ncur<0) ncur=0; return ncur;} 
int incr(int& ncur, int N){ncur++; if(ncur>=N) ncur=N-1; return ncur;} 

int MonotIncrease(CMyTime *tims, int N, int key)
{
  int m, n, k;
  CMyTime* pcmt = new CMyTime;
  for(m=0; m<N-1; m++){
    k = m;
    for(n=m+1; n<N; n++){
      if((key&&(tims[k]>tims[n]))||((!key)&&(tims[k]<tims[n]))) k=n;
    }
    if(m<k){
      *pcmt = tims[m];
      tims[m] = tims[k];
      tims[k] = *pcmt;
    }
  }
  delete pcmt;
  return true; 
}
int Randomize(CMyTime *tims, int N)
{
  int m, n, k;
  CMyTime* pcmt = new CMyTime;
  for(m=0; m<N-1; m++)
  {
    for(n=m+1; n<N; n++)
    {
      if(rand()%2){
        *pcmt = tims[m];
        tims[m] = tims[n];
        tims[n] = *pcmt;
	  }
    }
  }
  delete pcmt;
  return true; 
}

